// dir-tree.c 
//            wolf 10/95
// very simple demo for the Tree classes in grafix

#include "tree.h"

// #include "files.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>

class DirTree;

typedef list <DirTree> Dlist;

class DirTree : public Tree {
  char *path;
public:
  DirTree(char *name, char *path) : Tree(name), path(path) {}
  // virtual void Press_cb(XButtonEvent *ev) -> todo on button press
  virtual void Enter_cb(window *infw) { infw->clear(); infw->PlaceText(path); }
};

char *help_text[] = { "help me !", 0 };

class Dir_main : public Tree_main {
public: 
  Dir_main(char * WMName, int w, int h, Dlist *dll) : 
  Tree_main(WMName,w,h, (Tlist *) dll) {
    new help_button(*mb,"help",help_text);
  }
  // virtual void init() { Tree_main::init(); }
};

// recursively read directory tree, "dll" is linear list
// parent the parent Node 
void rec_dir(char *path, Dlist* &dll, DirTree* parent) {
  printf("reading directory %s\n",path);
  DIR *dirp = opendir(path);
  if (dirp == 0) printf("can't open %s\n",path);
  struct dirent *dp; 
  for (dp = readdir(dirp); dp != NULL; dp = readdir(dirp)) {
    int length = strlen(dp->d_name);
    if (dp->d_name[length-1] != '.') { // not for . or .. file
      int plen = strlen(path); 
      if (path[plen-1] == '/') path[plen-1] = 0; // eliminate tail-slashes
      char *fina = new char[length+strlen(path)+2];
      sprintf(fina,"%s/%s",path,dp->d_name); // complete path
      struct stat st;
      if (!stat(fina, &st) && S_ISDIR(st.st_mode) && !S_ISLNK(st.st_mode)) {
	// *** problem with symbolic links : how to exclude ???? ***
	// printf("reading directory %s %o\n",fina,st.st_mode);
	char *tail = strrchr(fina,'/'); // eliminate trailing path
	if (tail == 0) tail = fina; else tail++;
	DirTree *dt = new DirTree(tail,fina);
	dll = dll->push(dt); // append to linar list
	parent->children = parent->children->push(dt); // updtate parent list
	rec_dir(fina,dll,dt);
      }
    }
  }
  closedir(dirp);
}

// if commandline arg given use it as search path, else use ".."
int main(int argc, char* argv[]) {
  char *path = (argc > 1) ? argv[1] : ".."; //getenv("HOME");
  DirTree *top = new DirTree(path,path);
  Dlist *alldirs = new Dlist(top); // the top of the tree
  rec_dir(path,alldirs,top);
  Dir_main *mw = new Dir_main(argv[0],400,450,alldirs);
  mw->init();
  mw->main_loop();
}
